Index: /trunk/sources/HeuristicLab.RealVector/BoundsChecker.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/BoundsChecker.cs	(revision 101)
+++ /trunk/sources/HeuristicLab.RealVector/BoundsChecker.cs	(revision 102)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.RealVector {
-  class BoundsChecker : OperatorBase {
+  public class BoundsChecker : OperatorBase {
     public override string Description {
       get { return "Checks if all elements of a real vector are inside a given minimum and maximum value. If not, elements are corrected."; }
Index: /trunk/sources/HeuristicLab.RealVector/CompleteContinuousCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/CompleteContinuousCrossover.cs	(revision 101)
+++ /trunk/sources/HeuristicLab.RealVector/CompleteContinuousCrossover.cs	(revision 102)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.RealVector {
-  class CompleteContinuousCrossover : RealVectorCrossoverBase {
+  public class CompleteContinuousCrossover : RealVectorCrossoverBase {
     public override string Description {
       get { return "Complete continuous crossover for real vectors."; }
Index: /trunk/sources/HeuristicLab.RealVector/ContinuousCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/ContinuousCrossover.cs	(revision 101)
+++ /trunk/sources/HeuristicLab.RealVector/ContinuousCrossover.cs	(revision 102)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.RealVector {
-  class ContinuousCrossover : RealVectorCrossoverBase {
+  public class ContinuousCrossover : RealVectorCrossoverBase {
     public override string Description {
       get { return "Continuous crossover for real vectors."; }
Index: /trunk/sources/HeuristicLab.RealVector/DiscreteCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/DiscreteCrossover.cs	(revision 101)
+++ /trunk/sources/HeuristicLab.RealVector/DiscreteCrossover.cs	(revision 102)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.RealVector {
-  class DiscreteCrossover : RealVectorCrossoverBase {
+  public class DiscreteCrossover : RealVectorCrossoverBase {
     public override string Description {
       get { return "Discrete crossover for real vectors."; }
Index: /trunk/sources/HeuristicLab.RealVector/HeuristicCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/HeuristicCrossover.cs	(revision 101)
+++ /trunk/sources/HeuristicLab.RealVector/HeuristicCrossover.cs	(revision 102)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.RealVector {
-  class HeuristicCrossover : CrossoverBase {
+  public class HeuristicCrossover : CrossoverBase {
     public HeuristicCrossover()
       : base() {
Index: /trunk/sources/HeuristicLab.RealVector/LocalCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/LocalCrossover.cs	(revision 101)
+++ /trunk/sources/HeuristicLab.RealVector/LocalCrossover.cs	(revision 102)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.RealVector {
-  class LocalCrossover : RealVectorCrossoverBase {
+  public class LocalCrossover : RealVectorCrossoverBase {
     public override string Description {
       get { return "Local crossover for real vectors."; }
Index: /trunk/sources/HeuristicLab.RealVector/RandomConvexCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/RandomConvexCrossover.cs	(revision 101)
+++ /trunk/sources/HeuristicLab.RealVector/RandomConvexCrossover.cs	(revision 102)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.RealVector {
-  class RandomConvexCrossover : RealVectorCrossoverBase {
+  public class RandomConvexCrossover : RealVectorCrossoverBase {
     public override string Description {
       get { return "Random convex crossover for real vectors."; }
Index: /trunk/sources/HeuristicLab.RealVector/UniformAllPositionsManipulator.cs
===================================================================
--- /trunk/sources/HeuristicLab.RealVector/UniformAllPositionsManipulator.cs	(revision 101)
+++ /trunk/sources/HeuristicLab.RealVector/UniformAllPositionsManipulator.cs	(revision 102)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.RealVector {
-  class UniformAllPositionsManipulator : RealVectorManipulatorBase {
+  public class UniformAllPositionsManipulator : RealVectorManipulatorBase {
     public override string Description {
       get { return "Uniformly distributed change of all positions of a real vector."; }
Index: /trunk/sources/HeuristicLab.Scheduling.JSSP/ItemListIndexer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Scheduling.JSSP/ItemListIndexer.cs	(revision 101)
+++ /trunk/sources/HeuristicLab.Scheduling.JSSP/ItemListIndexer.cs	(revision 102)
@@ -29,5 +29,5 @@
 
 namespace HeuristicLab.Scheduling.JSSP {
-  class ItemListIndexer : OperatorBase {
+  public class ItemListIndexer : OperatorBase {
     public override string Description {
       get { return @"TODO\r\nOperator description still missing ..."; }