Index: trunk/sources/HeuristicLab.TestFunctions/HeuristicLab.TestFunctions.csproj
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/HeuristicLab.TestFunctions.csproj	(revision 105)
+++ trunk/sources/HeuristicLab.TestFunctions/HeuristicLab.TestFunctions.csproj	(revision 106)
@@ -37,4 +37,6 @@
     <Reference Include="System" />
     <Reference Include="System.Data" />
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml" />
   </ItemGroup>
@@ -49,4 +51,11 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="TestFunctionEvaluatorBase.cs" />
+    <Compile Include="TestFunctionInjector.cs" />
+    <Compile Include="TestFunctionInjectorView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="TestFunctionInjectorView.Designer.cs">
+      <DependentUpon>TestFunctionInjectorView.cs</DependentUpon>
+    </Compile>
   </ItemGroup>
   <ItemGroup>
@@ -72,4 +81,9 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="TestFunctionInjectorView.resx">
+      <DependentUpon>TestFunctionInjectorView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjector.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjector.cs	(revision 106)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjector.cs	(revision 106)
@@ -0,0 +1,76 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.TestFunctions {
+  public class TestFunctionInjector : OperatorBase {
+    public override string Description {
+      get {
+        return @"Injects the necessary variables for optimizing a test function";
+      }
+    }
+
+    public bool Maximization {
+      get { return GetVariable("Maximization").GetValue<BoolData>().Data; }
+      set { GetVariable("Maximization").Value = new BoolData(value); }
+    }
+
+    public double Minimum {
+      get { return GetVariable("Minimum").GetValue<DoubleData>().Data; }
+      set { GetVariable("Minimum").Value = new DoubleData(value); }
+    }
+
+    public double Maximum {
+      get { return GetVariable("Maximum").GetValue<DoubleData>().Data; }
+      set { GetVariable("Maximum").Value = new DoubleData(value); }
+    }
+
+    public int Length {
+      get { return GetVariable("Length").GetValue<IntData>().Data; }
+      set { GetVariable("Length").Value = new IntData(value); }
+    }
+
+    public TestFunctionInjector()
+      : base() {
+      AddVariable(new Variable("Maximization", new BoolData(false)));
+      AddVariable(new Variable("Minimum", new DoubleData(-32.76)));
+      AddVariable(new Variable("Maximum", new DoubleData(32.76)));
+      AddVariable(new Variable("Length", new IntData(2)));
+    }
+
+    public override IOperation Apply(IScope scope) {
+      scope.AddVariable((IVariable)GetVariable("Maximization").Clone());
+      scope.AddVariable((IVariable)GetVariable("Minimum").Clone());
+      scope.AddVariable((IVariable)GetVariable("Maximum").Clone());
+      scope.AddVariable((IVariable)GetVariable("Length").Clone());
+      return null;
+    }
+
+    public override IView CreateView() {
+      return new TestFunctionInjectorView(this);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.Designer.cs	(revision 106)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.Designer.cs	(revision 106)
@@ -0,0 +1,128 @@
+﻿namespace HeuristicLab.TestFunctions {
+  partial class TestFunctionInjectorView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.DimensionLabel = new System.Windows.Forms.Label();
+      this.MinimumLabel = new System.Windows.Forms.Label();
+      this.maximumLabel = new System.Windows.Forms.Label();
+      this.maximizationCheckBox = new System.Windows.Forms.CheckBox();
+      this.dimensionTextBox = new System.Windows.Forms.TextBox();
+      this.minimumTextBox = new System.Windows.Forms.TextBox();
+      this.maximumTextBox = new System.Windows.Forms.TextBox();
+      this.SuspendLayout();
+      // 
+      // DimensionLabel
+      // 
+      this.DimensionLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.DimensionLabel.AutoSize = true;
+      this.DimensionLabel.Location = new System.Drawing.Point(4, 29);
+      this.DimensionLabel.Name = "DimensionLabel";
+      this.DimensionLabel.Size = new System.Drawing.Size(59, 13);
+      this.DimensionLabel.TabIndex = 1;
+      this.DimensionLabel.Text = "Dimension:";
+      // 
+      // MinimumLabel
+      // 
+      this.MinimumLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.MinimumLabel.AutoSize = true;
+      this.MinimumLabel.Location = new System.Drawing.Point(4, 55);
+      this.MinimumLabel.Name = "MinimumLabel";
+      this.MinimumLabel.Size = new System.Drawing.Size(51, 13);
+      this.MinimumLabel.TabIndex = 3;
+      this.MinimumLabel.Text = "Minimum:";
+      // 
+      // maximumLabel
+      // 
+      this.maximumLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.maximumLabel.AutoSize = true;
+      this.maximumLabel.Location = new System.Drawing.Point(4, 81);
+      this.maximumLabel.Name = "maximumLabel";
+      this.maximumLabel.Size = new System.Drawing.Size(54, 13);
+      this.maximumLabel.TabIndex = 5;
+      this.maximumLabel.Text = "Maximum:";
+      // 
+      // maximizationCheckBox
+      // 
+      this.maximizationCheckBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.maximizationCheckBox.AutoSize = true;
+      this.maximizationCheckBox.Location = new System.Drawing.Point(69, 3);
+      this.maximizationCheckBox.Name = "maximizationCheckBox";
+      this.maximizationCheckBox.Size = new System.Drawing.Size(86, 17);
+      this.maximizationCheckBox.TabIndex = 0;
+      this.maximizationCheckBox.Text = "Maximization";
+      this.maximizationCheckBox.UseVisualStyleBackColor = true;
+      // 
+      // dimensionTextBox
+      // 
+      this.dimensionTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.dimensionTextBox.Location = new System.Drawing.Point(69, 26);
+      this.dimensionTextBox.Name = "dimensionTextBox";
+      this.dimensionTextBox.Size = new System.Drawing.Size(100, 20);
+      this.dimensionTextBox.TabIndex = 2;
+      // 
+      // minimumTextBox
+      // 
+      this.minimumTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.minimumTextBox.Location = new System.Drawing.Point(69, 52);
+      this.minimumTextBox.Name = "minimumTextBox";
+      this.minimumTextBox.Size = new System.Drawing.Size(100, 20);
+      this.minimumTextBox.TabIndex = 4;
+      // 
+      // maximumTextBox
+      // 
+      this.maximumTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.maximumTextBox.Location = new System.Drawing.Point(69, 78);
+      this.maximumTextBox.Name = "maximumTextBox";
+      this.maximumTextBox.Size = new System.Drawing.Size(100, 20);
+      this.maximumTextBox.TabIndex = 6;
+      // 
+      // TestFunctionInjectorView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.maximumTextBox);
+      this.Controls.Add(this.minimumTextBox);
+      this.Controls.Add(this.dimensionTextBox);
+      this.Controls.Add(this.maximizationCheckBox);
+      this.Controls.Add(this.maximumLabel);
+      this.Controls.Add(this.MinimumLabel);
+      this.Controls.Add(this.DimensionLabel);
+      this.Name = "TestFunctionInjectorView";
+      this.Size = new System.Drawing.Size(173, 101);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label DimensionLabel;
+    private System.Windows.Forms.Label MinimumLabel;
+    private System.Windows.Forms.Label maximumLabel;
+    private System.Windows.Forms.CheckBox maximizationCheckBox;
+    private System.Windows.Forms.TextBox dimensionTextBox;
+    private System.Windows.Forms.TextBox minimumTextBox;
+    private System.Windows.Forms.TextBox maximumTextBox;
+  }
+}
Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.cs	(revision 106)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.cs	(revision 106)
@@ -0,0 +1,88 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.TestFunctions {
+  public partial class TestFunctionInjectorView : ViewBase {
+    public TestFunctionInjector TestFunctionInjector {
+      get { return (TestFunctionInjector)base.Item; }
+      set { base.Item = value; }
+    }
+
+    public TestFunctionInjectorView() {
+      InitializeComponent();
+    }
+
+    public TestFunctionInjectorView(TestFunctionInjector testFunctionInjector)
+      : this() {
+      TestFunctionInjector = testFunctionInjector;
+    }
+
+    protected override void RemoveItemEvents() {
+      maximizationCheckBox.DataBindings.Clear();
+      dimensionTextBox.DataBindings.Clear();
+      minimumTextBox.DataBindings.Clear();
+      maximumTextBox.DataBindings.Clear();
+      base.RemoveItemEvents();
+    }
+
+    protected override void AddItemEvents() {
+      base.AddItemEvents();
+      maximizationCheckBox.DataBindings.Add("Checked", TestFunctionInjector, "Maximization");
+      dimensionTextBox.DataBindings.Add("Text", TestFunctionInjector, "Length");
+      minimumTextBox.DataBindings.Add("Text", TestFunctionInjector, "Minimum");
+      maximumTextBox.DataBindings.Add("Text", TestFunctionInjector, "Maximum");
+    }
+
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      if (TestFunctionInjector == null) {
+        maximizationCheckBox.Enabled = false;
+        maximizationCheckBox.Checked = false;
+        dimensionTextBox.Enabled = false;
+        dimensionTextBox.Text = "-";
+        minimumTextBox.Enabled = false;
+        minimumTextBox.Text = "-";
+        maximumTextBox.Enabled = false;
+        maximumTextBox.Text = "-";
+      } else {
+        /*maximizationCheckBox.Checked = TestFunctionInjector.Maximization;
+        dimensionTextBox.Text = TestFunctionInjector.Length.ToString();
+        minimumTextBox.Text = TestFunctionInjector.Minimum.ToString();
+        maximumTextBox.Text = TestFunctionInjector.Maximum.ToString();*/
+        maximizationCheckBox.Enabled = true;
+        dimensionTextBox.Enabled = true;
+        minimumTextBox.Enabled = true;
+        maximumTextBox.Enabled = true;
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.resx
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.resx	(revision 106)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.resx	(revision 106)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>