Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjector.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjector.cs	(revision 108)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjector.cs	(revision 109)
@@ -39,17 +39,17 @@
     }
 
-    public double Minimum {
-      get { return GetVariable("Minimum").GetValue<DoubleData>().Data; }
-      set { GetVariable("Minimum").Value = new DoubleData(value); }
+    public double LowerBound {
+      get { return GetVariable("LowerBound").GetValue<DoubleData>().Data; }
+      set { GetVariable("LowerBound").Value = new DoubleData(value); }
     }
 
-    public double Maximum {
-      get { return GetVariable("Maximum").GetValue<DoubleData>().Data; }
-      set { GetVariable("Maximum").Value = new DoubleData(value); }
+    public double UpperBound {
+      get { return GetVariable("UpperBound").GetValue<DoubleData>().Data; }
+      set { GetVariable("UpperBound").Value = new DoubleData(value); }
     }
 
-    public int Length {
-      get { return GetVariable("Length").GetValue<IntData>().Data; }
-      set { GetVariable("Length").Value = new IntData(value); }
+    public int Dimension {
+      get { return GetVariable("Dimension").GetValue<IntData>().Data; }
+      set { GetVariable("Dimension").Value = new IntData(value); }
     }
 
@@ -59,12 +59,12 @@
       AddVariable(new Variable("Minimum", new DoubleData(-32.76)));
       AddVariable(new Variable("Maximum", new DoubleData(32.76)));
-      AddVariable(new Variable("Length", new IntData(2)));
+      AddVariable(new Variable("Dimension", new IntData(2)));
     }
 
     public override IOperation Apply(IScope scope) {
       scope.AddVariable((IVariable)GetVariable("Maximization").Clone());
-      scope.AddVariable((IVariable)GetVariable("Minimum").Clone());
-      scope.AddVariable((IVariable)GetVariable("Maximum").Clone());
-      scope.AddVariable((IVariable)GetVariable("Length").Clone());
+      scope.AddVariable((IVariable)GetVariable("LowerBound").Clone());
+      scope.AddVariable((IVariable)GetVariable("UpperBound").Clone());
+      scope.AddVariable((IVariable)GetVariable("Dimension").Clone());
       return null;
     }
Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.Designer.cs	(revision 108)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.Designer.cs	(revision 109)
@@ -29,6 +29,6 @@
       this.maximizationCheckBox = new System.Windows.Forms.CheckBox();
       this.dimensionTextBox = new System.Windows.Forms.TextBox();
-      this.minimumTextBox = new System.Windows.Forms.TextBox();
-      this.maximumTextBox = new System.Windows.Forms.TextBox();
+      this.lowerBoundTextBox = new System.Windows.Forms.TextBox();
+      this.upperBoundTextBox = new System.Windows.Forms.TextBox();
       this.SuspendLayout();
       // 
@@ -37,5 +37,5 @@
       this.DimensionLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.DimensionLabel.AutoSize = true;
-      this.DimensionLabel.Location = new System.Drawing.Point(4, 29);
+      this.DimensionLabel.Location = new System.Drawing.Point(3, 29);
       this.DimensionLabel.Name = "DimensionLabel";
       this.DimensionLabel.Size = new System.Drawing.Size(59, 13);
@@ -47,9 +47,9 @@
       this.MinimumLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.MinimumLabel.AutoSize = true;
-      this.MinimumLabel.Location = new System.Drawing.Point(4, 55);
+      this.MinimumLabel.Location = new System.Drawing.Point(3, 55);
       this.MinimumLabel.Name = "MinimumLabel";
-      this.MinimumLabel.Size = new System.Drawing.Size(51, 13);
+      this.MinimumLabel.Size = new System.Drawing.Size(73, 13);
       this.MinimumLabel.TabIndex = 3;
-      this.MinimumLabel.Text = "Minimum:";
+      this.MinimumLabel.Text = "Lower Bound:";
       // 
       // maximumLabel
@@ -57,9 +57,9 @@
       this.maximumLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.maximumLabel.AutoSize = true;
-      this.maximumLabel.Location = new System.Drawing.Point(4, 81);
+      this.maximumLabel.Location = new System.Drawing.Point(3, 81);
       this.maximumLabel.Name = "maximumLabel";
-      this.maximumLabel.Size = new System.Drawing.Size(54, 13);
+      this.maximumLabel.Size = new System.Drawing.Size(73, 13);
       this.maximumLabel.TabIndex = 5;
-      this.maximumLabel.Text = "Maximum:";
+      this.maximumLabel.Text = "Upper Bound:";
       // 
       // maximizationCheckBox
@@ -67,5 +67,5 @@
       this.maximizationCheckBox.Anchor = System.Windows.Forms.AnchorStyles.None;
       this.maximizationCheckBox.AutoSize = true;
-      this.maximizationCheckBox.Location = new System.Drawing.Point(69, 3);
+      this.maximizationCheckBox.Location = new System.Drawing.Point(83, 3);
       this.maximizationCheckBox.Name = "maximizationCheckBox";
       this.maximizationCheckBox.Size = new System.Drawing.Size(86, 17);
@@ -77,24 +77,24 @@
       // 
       this.dimensionTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.dimensionTextBox.Location = new System.Drawing.Point(69, 26);
+      this.dimensionTextBox.Location = new System.Drawing.Point(82, 26);
       this.dimensionTextBox.Name = "dimensionTextBox";
       this.dimensionTextBox.Size = new System.Drawing.Size(100, 20);
       this.dimensionTextBox.TabIndex = 2;
       // 
-      // minimumTextBox
+      // lowerBoundTextBox
       // 
-      this.minimumTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.minimumTextBox.Location = new System.Drawing.Point(69, 52);
-      this.minimumTextBox.Name = "minimumTextBox";
-      this.minimumTextBox.Size = new System.Drawing.Size(100, 20);
-      this.minimumTextBox.TabIndex = 4;
+      this.lowerBoundTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.lowerBoundTextBox.Location = new System.Drawing.Point(82, 52);
+      this.lowerBoundTextBox.Name = "lowerBoundTextBox";
+      this.lowerBoundTextBox.Size = new System.Drawing.Size(100, 20);
+      this.lowerBoundTextBox.TabIndex = 4;
       // 
-      // maximumTextBox
+      // upperBoundTextBox
       // 
-      this.maximumTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.maximumTextBox.Location = new System.Drawing.Point(69, 78);
-      this.maximumTextBox.Name = "maximumTextBox";
-      this.maximumTextBox.Size = new System.Drawing.Size(100, 20);
-      this.maximumTextBox.TabIndex = 6;
+      this.upperBoundTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.upperBoundTextBox.Location = new System.Drawing.Point(82, 78);
+      this.upperBoundTextBox.Name = "upperBoundTextBox";
+      this.upperBoundTextBox.Size = new System.Drawing.Size(100, 20);
+      this.upperBoundTextBox.TabIndex = 6;
       // 
       // TestFunctionInjectorView
@@ -102,6 +102,6 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.maximumTextBox);
-      this.Controls.Add(this.minimumTextBox);
+      this.Controls.Add(this.upperBoundTextBox);
+      this.Controls.Add(this.lowerBoundTextBox);
       this.Controls.Add(this.dimensionTextBox);
       this.Controls.Add(this.maximizationCheckBox);
@@ -110,5 +110,5 @@
       this.Controls.Add(this.DimensionLabel);
       this.Name = "TestFunctionInjectorView";
-      this.Size = new System.Drawing.Size(173, 101);
+      this.Size = new System.Drawing.Size(186, 101);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -123,6 +123,6 @@
     private System.Windows.Forms.CheckBox maximizationCheckBox;
     private System.Windows.Forms.TextBox dimensionTextBox;
-    private System.Windows.Forms.TextBox minimumTextBox;
-    private System.Windows.Forms.TextBox maximumTextBox;
+    private System.Windows.Forms.TextBox lowerBoundTextBox;
+    private System.Windows.Forms.TextBox upperBoundTextBox;
   }
 }
Index: trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.cs
===================================================================
--- trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.cs	(revision 108)
+++ trunk/sources/HeuristicLab.TestFunctions/TestFunctionInjectorView.cs	(revision 109)
@@ -50,6 +50,6 @@
       maximizationCheckBox.DataBindings.Clear();
       dimensionTextBox.DataBindings.Clear();
-      minimumTextBox.DataBindings.Clear();
-      maximumTextBox.DataBindings.Clear();
+      lowerBoundTextBox.DataBindings.Clear();
+      upperBoundTextBox.DataBindings.Clear();
       base.RemoveItemEvents();
     }
@@ -58,7 +58,7 @@
       base.AddItemEvents();
       maximizationCheckBox.DataBindings.Add("Checked", TestFunctionInjector, "Maximization");
-      dimensionTextBox.DataBindings.Add("Text", TestFunctionInjector, "Length");
-      minimumTextBox.DataBindings.Add("Text", TestFunctionInjector, "Minimum");
-      maximumTextBox.DataBindings.Add("Text", TestFunctionInjector, "Maximum");
+      dimensionTextBox.DataBindings.Add("Text", TestFunctionInjector, "Dimension");
+      lowerBoundTextBox.DataBindings.Add("Text", TestFunctionInjector, "LowerBound");
+      upperBoundTextBox.DataBindings.Add("Text", TestFunctionInjector, "UpperBound");
     }
 
@@ -70,17 +70,13 @@
         dimensionTextBox.Enabled = false;
         dimensionTextBox.Text = "-";
-        minimumTextBox.Enabled = false;
-        minimumTextBox.Text = "-";
-        maximumTextBox.Enabled = false;
-        maximumTextBox.Text = "-";
+        lowerBoundTextBox.Enabled = false;
+        lowerBoundTextBox.Text = "-";
+        upperBoundTextBox.Enabled = false;
+        upperBoundTextBox.Text = "-";
       } else {
-        /*maximizationCheckBox.Checked = TestFunctionInjector.Maximization;
-        dimensionTextBox.Text = TestFunctionInjector.Length.ToString();
-        minimumTextBox.Text = TestFunctionInjector.Minimum.ToString();
-        maximumTextBox.Text = TestFunctionInjector.Maximum.ToString();*/
         maximizationCheckBox.Enabled = true;
         dimensionTextBox.Enabled = true;
-        minimumTextBox.Enabled = true;
-        maximumTextBox.Enabled = true;
+        lowerBoundTextBox.Enabled = true;
+        upperBoundTextBox.Enabled = true;
       }
     }